import dynamix_sdk.base as _base
import dynamix_sdk.api._nested as _nested


class CloudapiAccountGetResultModel(
    _base.BaseAPIResultModel,
    _nested.AccountAPIResultNM,
):
    company: str
    company_url: str
    cpu_allocation_parameter: str
    cpu_allocation_ratio: int
    created_by: str
    dc_location: str
    deactivation_timestamp: int
    deleted_by: str
    display_name: str
    guid: int
    quotas: _nested.TenantQuotasAPIResultNM
    resource_types: list[_nested.AccountResourceType]
    send_access_emails: bool
    uniq_pools: list[str]
    version: int
    vins_count: int
    acc_lvl_vins_ids: list[int]
    vm_counts: _nested.VMCountsAPIResultNM

    @property
    def deactivation_datetime(self):
        return self._get_datetime_from_timestamp(self.deactivation_timestamp)


class CloudapiAccountGetProtocol(_base.BasePostAPIFunctionProtocol):
    def get(
        self,
        *,
        account_id: int,
    ) -> CloudapiAccountGetResultModel:
        ...
