import dynamix_sdk.base as _base
import dynamix_sdk.api._nested as _nested


class CloudapiFlipgroupGetResultModel(
    _base.BaseAPIResultModel,
    _nested.BaseFlipGroupAPIResultNM,
):
    account_name: str
    client_names: list[str]
    created_by: str
    created_timestamp: int
    deleted_by: str
    deleted_timestamp: int
    net_cidr: str
    rg_id: int
    rg_name: str
    updated_by: str
    updated_timestamp: int

    @property
    def created_datetime(self):
        return self._get_datetime_from_timestamp(self.created_timestamp)

    @property
    def deleted_datetime(self):
        return self._get_datetime_from_timestamp(self.deleted_timestamp)

    @property
    def updated_datetime(self):
        return self._get_datetime_from_timestamp(self.updated_timestamp)


class CloudapiFlipgroupGetProtocol(_base.BasePostAPIFunctionProtocol):
    def get(
        self,
        *,
        flip_group_id: int,
    ) -> CloudapiFlipgroupGetResultModel:
        ...
